//
//  CasseView.m
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "CasseView.h"
#import "SaveBrick.h"
#import "MyDocument.h"

@implementation CasseView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        paddle = [[Paddle alloc] init];
		paused = YES;
		ball = [[Ball alloc] init];
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    // Drawing code here.
	int i;
	SaveBrick *brick;
	NSRect brickRect;
	
	for(i=0;i<[currentLevel count];i++){
		brick = [currentLevel objectAtIndex:i];
		brickRect = NSMakeRect([brick x] * 40, [brick y] * 20,40,20);
		if (NSIntersectsRect(rect,brickRect)) {
			[brick drawBrick];
		}
	}
	
	[paddle drawPaddle];
	[ball drawBall];
}

- (void) mouseUp:(NSEvent *)event
{
	paused = !paused;
	if ([document lives] < 1) {
		paused = YES;
	}
	NSLog(@"Pause: %d", paused);
	if (paused) {
		if ([document lives] > 0 ){
			[timer invalidate];
		}
	} else {
		timer =  [NSTimer scheduledTimerWithTimeInterval:(1.0/50) target:self selector:@selector(animate:) userInfo:nil repeats:YES];
	}
}

- (BOOL)paused
{
	return paused;
}

-(void)pauseAnim;
{
	paused = YES;
	[timer invalidate];
}

-(void) startLevel {
	srandom(time(NULL));
	currentLevel = [document currentLevel];
	[paddle release];
	paddle = [[Paddle alloc] init];
	[ball release];
	ball = [[Ball alloc] init];
	if (!paused) {
		[self pauseAnim];
	}
}

-(int)bricksRemaining {
	SaveBrick *brick;
	int i;
	int bricks=0;
	
	for(i=0;i<[currentLevel count];i++){
		brick = [currentLevel objectAtIndex:i];
			if (([brick type]==1) || ([brick type] == 5))  {
			bricks++;
		}
	}
	return bricks;
}

-(void) animate:(NSTimer*)theTimer
{
	int i;
	SaveBrick *brick;
	NSPoint q;
	NSPoint r;
	NSPoint p =[NSEvent mouseLocation];
	NSRect brickRect;
	r = [[self window] convertScreenToBase:p];
	q = [self convertPoint:r fromView:nil];
	[paddle movePaddleToX:q.x];
	[ball moveBall];
	
	//death code
	if ([ball y]<1) {
		[document setLives:([document lives]-1)];
		[self pauseAnim];
		[ball release];
		ball = [[Ball alloc] init];
		[self setNeedsDisplay:YES];

	}
	
	NSLog (@"Bricks: %d", [self bricksRemaining]); 
	
	//Collision Detection Time
	if (NSIntersectsRect([ball location], [paddle location])) {
		[ball collideWithPaddleAt:(-1*([paddle x] + 40 - [ball x]))];
	}
	
	for(i=0;i<[currentLevel count];i++){
		brick = [currentLevel objectAtIndex:i];
		brickRect = NSMakeRect([brick x] * 40, [brick y] * 20,40,20);
		if (NSIntersectsRect([ball location],brickRect)) {
			[ball collideWithBrickType:[brick type]];
			if ([brick type] == 1 ) {
				[currentLevel removeObjectAtIndex:i];
				i--;
			} else {
				if ([brick type] == 5) {
					[brick setType:(random()%8+1)];
				}
			}
		}
	}
	if ([self bricksRemaining] < 1) {
		[document setLives:([document lives]+1)];
		[document nextLevel:self];
	}
	[self setNeedsDisplay:YES];
}

@end
