//
//  MyDocument.m
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright __MyCompanyName__ 2006 . All rights reserved.
//

#import "MyDocument.h"
#import "SaveBrick.h"
#import "CasseView.h"

@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) {
		levels = [[NSMutableArray alloc] init];
	}
    return self;
}

-(void) setEvent
{
	[w setAcceptsMouseMovedEvents:![view paused]];
}


- (IBAction) nextLevel:(id)sender
{
	[self updateLevel];
	level++;
	if (level > ([levels count])) {
		level = [levels count];
	}
	[view startLevel];
	[self updateUI];
}

- (IBAction) prevLevel:(id)sender
{
	[self updateLevel];
	level--;
	[view startLevel];
	[self updateUI];
}

- (void) updateLevel
{
}

- (void) updateUI
{
	NSString *levelInfo = [NSString stringWithFormat:@"Level: %d of %d", level+1, [levels count]];
	NSString *livesInfo = [NSString stringWithFormat:@"Lives: %d", lives]; 
	if (level == [levels count]) {
		[textOut setStringValue:@"You Win!"]; 
	} else {
		[textOut setStringValue:levelInfo];
	}
	[livesText setStringValue:livesInfo];
	
	[prevButton setEnabled:(level>0)];
	[nextButton setEnabled:(level < [levels count] -1)];
	[view setNeedsDisplay:YES];
}

-(void) addBrickAtX:(int)x Y:(int)y
{
	int i;
	NSMutableArray *currentLevel =[levels objectAtIndex:level];
	SaveBrick *brick;
	NSRect theRect={{x*40, y*20}, {40, 20}};
	NSLog(@"brickType: %d", brickType);
	if (brickType>0) {
		brick = [[SaveBrick alloc] initWithX:x Y:y Type:brickType];
		[currentLevel addObject:brick];
		[brick release];
		[view drawRect:theRect];
	} else {
		for(i=0; i<[currentLevel count]; i++) {
			if (([[currentLevel objectAtIndex:i] x] == x) && ([[currentLevel objectAtIndex:i] y] == y)) {
				[[currentLevel objectAtIndex:i] setType:0];
				[view drawRect:theRect];
				[currentLevel removeObjectAtIndex:i];
				i--;
			}
		}
	}
}

- (id)currentLevel
{
	return [levels objectAtIndex:level];
}

-(void)setLives:(int)l
{
	if (l > 999) {
		lives = 999;
	} else {
		lives = l;
	}
	[self updateUI];
}

-(int)lives
{
	return lives;
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
	[view startLevel];
	[self setLives:4];
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API -dataOfType:error:.  In this case you can also choose to override -writeToURL:ofType:error:, -fileWrapperOfType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.

    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API readFromData:ofType:error:.  In this case you can also choose to override -readFromURL:ofType:error: or -readFromFileWrapper:ofType:error: instead.
    
    [levels release];
	levels = [[NSUnarchiver unarchiveObjectWithData:data] retain];
	[self updateUI];
    return YES;

}

- (void) dealloc
{
	[levels release];
	[super dealloc];
}

@end
