//
//  MyDocument.m
//  CasseEdit
//
//  Created by Yeolcoatl on 1/14/06.
//  Copyright __MyCompanyName__ 2006 . All rights reserved.
//

#import "MyDocument.h"
#import "SaveBrick.h"

@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) {
    
		levels = [[NSMutableArray alloc] init];
		[self createNewLevel];
    }
    return self;
}

- (IBAction) newLevel:(id)sender
{
	[self createNewLevel];
	[self updateChangeCount:NSChangeDone];
	[self nextLevel:self];
	[self updateUI];
}
- (IBAction) deleteLevel:(id)sender
{
	[levels removeObjectAtIndex:level];
	if (level!=0) {
		level--;
	}
	[self updateUI];
}

- (IBAction) changeBrick:(id)sender
{
	brickType = [sender selectedRow];
	NSLog(@"Type: %d",brickType);
}

- (IBAction) nextLevel:(id)sender
{
	[self updateLevel];
	level++;
	[self updateUI];
}

- (IBAction) prevLevel:(id)sender
{
	[self updateLevel];
	level--;
	[self updateUI];
}

- (void) createNewLevel
{
	NSMutableArray *newLevel = [[NSMutableArray alloc]init];
	[levels addObject:newLevel];
	[newLevel release];
}
- (void) updateLevel
{
}

- (void) updateUI
{
	NSString *levelInfo = [NSString stringWithFormat:@"Level: %d of %d", level+1, [levels count]];
	[textOut setStringValue:levelInfo];
	
	[prevButton setEnabled:(level>0)];
	[nextButton setEnabled:(level < [levels count] -1)];
	[deleteButton setEnabled:([levels count] > 1)];
	[view setNeedsDisplay:YES];
}

-(void) addBrickAtX:(int)x Y:(int)y
{
	int i;
	NSMutableArray *currentLevel =[levels objectAtIndex:level];
	SaveBrick *brick;
	NSRect theRect={{x*40, y*20}, {40, 20}};
	NSLog(@"brickType: %d", brickType);
	if (brickType>0) {
		brick = [[SaveBrick alloc] initWithX:x Y:y Type:brickType];
		[currentLevel addObject:brick];
		[brick release];
		[view drawRect:theRect];
	} else {
		for(i=0; i<[currentLevel count]; i++) {
			if (([[currentLevel objectAtIndex:i] x] == x) && ([[currentLevel objectAtIndex:i] y] == y)) {
				[[currentLevel objectAtIndex:i] setType:0];
				[view drawRect:theRect];
				[currentLevel removeObjectAtIndex:i];
				i--;
			}
		}
	}
}

- (id)currentLevel
{
	return [levels objectAtIndex:level];
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
	[self updateUI];
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API -dataOfType:error:.  In this case you can also choose to override -writeToURL:ofType:error:, -fileWrapperOfType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.

    return [NSArchiver archivedDataWithRootObject:levels];
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API readFromData:ofType:error:.  In this case you can also choose to override -readFromURL:ofType:error: or -readFromFileWrapper:ofType:error: instead.
    
    [levels release];
	levels = [[NSUnarchiver unarchiveObjectWithData:data] retain];
	[self updateUI];
    return YES;

}

- (void) dealloc
{
	[levels release];
	[super dealloc];
}

@end
